function onAppointmentWindowOpen(args) {

    var schObj = $("#routeSchedule").ejSchedule('instance');
    args.cancel = true;
    if (ej.isNullOrUndefined(args.appointment)) {
        if (args.startTime.setHours(0, 0, 0, 0) < new Date().setHours(0, 0, 0, 0)) {
            args.cancel = true;
            return;
        }
    }
    else {
        if (new Date(args.appointment.StartTime).setHours(0, 0, 0, 0) < new Date().setHours(0, 0, 0, 0)) {
            args.cancel = true;
            return;
        }   
    }
    $("#recurrence").ejCheckBox({ checked: false, enabled: true });
    $("#recWindow").css("display", "none");
    $("#editApp").css("display", "none");
    $("#appWindow").css("display", "block");

    // When double clicked on the Scheduler cells, fills the StartTime and EndTime fields appropriately
    $("#StartTime").ejDateTimePicker({ value: args.startTime });
    $("#EndTime").ejDateTimePicker({ value: args.endTime });
    $("#recWindow").css("display", "none");
    $("#appWindow").css("display", "");
    $('#subject').val(subjectTime(new Date(args.endTime)));
    if (ej.isNullOrUndefined(args.appointment)) {
        $("#recurrenceEditor")
           .find("#startsoncount")
           .find("#" + "recurrenceEditor" + "_recurstartdate")
           .ejDatePicker("option",
           {
               value: ej.format(new Date(args.endTime), this._datepattern(), this.model.locale)
           });
    }
    if (args.model.currentView == "month") {
        var currentDate = new Date();
        var appointedDate = new Date(args.endTime);
        var currentappointedTime = new Date(appointedDate.getFullYear(),
            appointedDate.getMonth(),
            appointedDate.getDate(),
            currentDate.getHours(),
            currentDate.getMinutes(),
            currentDate.getSeconds());
        $("#StartTime").ejDateTimePicker({ value: subtract_minutes(currentappointedTime, window.checkInMinutes) });
        $("#EndTime").ejDateTimePicker({ value: currentappointedTime });
        $('#subject').val(subjectTime(new Date(currentappointedTime)));
    }
    if (ej.isNullOrUndefined(args.edit)) {
        var res = args.model.resources[0].resourceSettings.dataSource;
        $("#Territory").ejDropDownList({ dataSource: res, width: "100%", fields: { text: "Text", id: "Td", value: "Text" } });

        var res2 = new ej.DataManager(res).executeLocal(new ej.Query().where(args.model.resources[args.model.resources.length - 1].resourceSettings["id"],
            ej.FilterOperators.equal, args.resources.GroupId));
        var res1 = new ej.DataManager(args.model.resources[args.model.resources.length - 1].resourceSettings.dataSource).executeLocal(new ej.Query().where
            (args.model.resources[args.model.resources.length - 1].resourceSettings["groupId"], ej.FilterOperators.equal, args.resources.GroupId));
        $("#TerritoryRoutes").ejDropDownList({ dataSource: res1, width: "100%", fields: { text: "Text", id: "Td", value: "Text" } });

        $("#TerritoryRoutes").data("ejDropDownList").selectItemByText(args.resources.Text);
        $("#Territory").data("ejDropDownList").selectItemByText(res2[0].Text);

    } else {

        var res = new ej.DataManager(args.model.resources[0].resourceSettings.dataSource).executeLocal(new ej.Query().where(args.model.resources[0].resourceSettings["id"], ej.FilterOperators.equal, args.appointment.TerritoryId));
        $("#Territory").ejDropDownList({ dataSource: args.model.resources[0].resourceSettings.dataSource, fields: { text: "Text", id: "Id", value: "Text" } });
        $("#Territory").data("ejDropDownList").selectItemByText(res[0].Text);
        var res2 = new ej.DataManager(args.model.resources[args.model.resources.length - 1].resourceSettings.dataSource).executeLocal(new ej.Query().where(args.model.resources[args.model.resources.length - 1].resourceSettings["groupId"], ej.FilterOperators.equal, res[0].Id));
        $("#TerritoryRoutes").ejDropDownList({ dataSource: res2, fields: { text: "Text", id: "Id", value: "Text" } });
        var res1 = new ej.DataManager(args.model.resources[args.model.resources.length - 1].resourceSettings.dataSource).executeLocal(new ej.Query().where(args.model.resources[args.model.resources.length - 1].resourceSettings["id"], ej.FilterOperators.equal, args.appointment.RouteId));
        $("#TerritoryRoutes").data("ejDropDownList").selectItemByText(res1[0].Text);
        window.appedit = ej.isNullOrUndefined(args.waitinglistedit) ? true : false;
    }
    if (!ej.isNullOrUndefined(args.target)) {
        $('#recurrence').prop('disabled', false);
        recurCheck();
        $("#EndTime").ejDateTimePicker({
            enabled: ($(args.target.currentTarget).hasClass("e-alldaycells")) ? false : true
        });
    }
    if (!ej.isNullOrUndefined(args.appointment)) {
        window.appointmentRule = null;
        $("#customId").val(args.appointment.Id);
        $("#subject").val(args.appointment.Subject);
        $("#StartTime").ejDateTimePicker({ value: new Date(args.appointment.StartTime) });
        $("#EndTime").ejDateTimePicker({ value: new Date(args.appointment.EndTime) });
        // $("#recurrence").ejCheckBox({ checked: args.appointment.Recurrence });
        if (args.appointment.Recurrence) {
            $("#recurrence")
                .ejCheckBox({
                    checked: args.appointment.Recurrence,
                    enabled: (schObj._currentAction == "editSeries") ? true : false
                });
            if (schObj._currentAction == "editSeries") {
                $("#editApp").css("display", "block");
                window.appointmentRule = args.appointment.RecurrenceRule;
                $("#recurrenceEditor").find("#startsoncount")
                    .find("#" + "recurrenceEditor" + "_recurstartdate")
                     .ejDatePicker("option",
                            {
                                 value: ej.format(new Date(args.appointment.EndTime), this._datepattern(), this.model.locale)
                            });
            }
            var recObj = $("#recurrenceEditor").ejRecurrenceEditor('instance');
            recObj._recRule = args.appointment.RecurrenceRule; // app recurrence rule is stored in Recurrence editor object
            recObj.recurrenceRuleSplit(args.appointment.RecurrenceRule, args.appointment.recurrenceExDate); //splitting the recurrence rule
            recObj.showRecurrenceSummary(args.appointment.Id);
            window.recurRule = recObj._recRule;
            if (recObj._rRule.count !== undefined) {
                if (recObj._rRuleFreq == "DAILY") {
                    var newd = moment(new Date(args.appointment.EndTime));
                    var maxEndDate = newd.add((recObj._rRule.count - 1) * recObj._interval, 'days');
                    $("#recurrenceEditor").find("#endsonuntil").find("#" + "recurrenceEditor" + "_daily").ejDatePicker("option", {

                        value: ej.format(new Date(maxEndDate), this._datepattern(), this.model.locale)
                    });
                }
                
            }
        } else
            $("#recurrence").ejCheckBox({ checked: false, enabled: true });
        $("#recWindow").css("display", "none");
        $("#appWindow").css("display", "block");
    }
    $("#customWindow").ejDialog("open");
}

function save() {
    // checks if the subject value is not left blank before saving it.
    if ($.trim($("#subject").val()) == "") {
        $("#subject").addClass("error");
        return false;
    }
    var obj = {}, temp = {}, rType;
    var formelement = $("#customWindow").find("#custom").get(0);
    for (var index = 0; index < formelement.length; index++) {
        var columnName = formelement[index].name, $element = $(formelement[index]);
        if (columnName != undefined) {
            if (columnName == "")
                columnName = formelement[index].id.replace(this._id, "");
            if (columnName != "" && obj[columnName] == null) {
                var value = formelement[index].value;
                if (columnName == "Id" && value != "") {
                    value = parseInt(value);
                    window.appointedit = true;
                }
                if ($element.hasClass("e-datetimepicker"))
                    value = new Date(value);
                if (formelement[index].type == "checkbox")
                    value = formelement[index].checked;
                if (formelement[index].type == "hidden") {

                    var resdata = (columnName == "Territory") ? window.routeTerritories : window.routes;
                    var territoryId = new ej.DataManager(resdata).executeLocal(new ej.Query().where("Text", ej.FilterOperators.equal, value));
                    if (territoryId.length > 0)
                        (columnName == "Territory") ? obj["TerritoryId"] = territoryId[0].Id : obj["RouteId"] = territoryId[0].Id;
                }
                if (columnName != "Territory_hidden" &&
                    //columnName != "TerritoryRoutes" &&
                    columnName != "TerritoryRoutes_hidden") {
                    // console.log({ columnName, $element, value });
                    obj[columnName] = value;
                }
            }
        }
    }
 
    obj['RecurrenceRule'] = (obj.Recurrence) ? window.recurRule : null;
    obj["CompanyId"] = $('#Id').val();
    $("#customWindow").ejDialog("close");
  
    //var schObj = $("#routeSchedule").ejSchedule('instance');
    var schObj = $("#routeSchedule").data("ejSchedule");
    if (obj.Recurrence) {
        var recurEdit = schObj._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor");
        recurEdit._recRule = obj[schObj._appointmentSettings["recurrenceRule"]];
    }

    schObj.saveAppointment(obj);
    clearFields();
}


