var RoutesDefaults = {
    formSelector: '#search-form',
    resultsHolderSelector: '#results',
    companydetailsurl: '/Admin/Apps/SyncBus/Company/Details/',
    routeTerritoriesResUrl: '/Admin/Apps/SyncBus/Route/RouteTerritoriesResources/',
    routeTerritoriesUrl: '/Admin/Apps/SyncBus/Route/RouteTerritories/',
    IdSelector: '#Id'
}

var customizationMessage = {
    // customize the appointment window title
    CreateAppointmentTitle: "Create Schedule",
    Editevent: "Edit Schedule",
    AddEvent: "Add Schedule",
    DeleteConfirmation: "Are you sure you want to delete this?",
    RecurrenceEditTitle: "Edit Repeat Schedule",
    RecurrenceEditMessage: "How would you like to change the schedule in the series?",
    RecurrenceEditOnly: "Only this Schedule",
    EventBeginsin: "Schedule will Open in",
    Eventwas: "Schedule was",
    Overdue: "Overdue Schedule",
    RecurrenceDeleteTitle: "Delete Repeat Schedule",
    PreviousAppointment: "Previous Schedule",
    NextAppointment: "Next Schedule",
    MouseOverDeleteTitle: "Delete this Schedule",
};

// Extend only the required changes to the original locale collection
$.extend(ej.Schedule.Locale["en-US"], customizationMessage);

$("#btnsubmit,#btncancel,#appsubmit,#appcancel,#recsubmit,#reccancel,#alertok,#alertcancel").ejButton({
    size: "normal",
    width: "70px",
    showRoundedCorner: false
});

$("#appcancel,#appsubmit").ejButton({ click: "onAppointmentClick" });
$("#reccancel,#recsubmit").ejButton({ click: "onRecurrenceClick" });

$(document).ready(function () {

    $("#appWindow").find(".recuredit").click(function () { onRecurrenceRule(); });
    //console.log(window.routes);
});


/* Schedule Navigation */
function OnNavigation(args) {
    $("#datepicker").ejDatePicker({ value: new Date(args.currentDate) });
}

// DatePicker Selection
function routeDateSelected(args) {
    $("#routeSchedule").ejSchedule({ currentDate: new Date(args.value) });
}


function onRouteSelect(args) {
    var instance = $("#routeRegionList").data("ejDropDownList");
    var companyid = $('#Id').val();
    var currentRouteList = new ej.DataManager(window.routes).executeLocal(new ej.Query().where("Text", "equal", args.text));
    var territoryList = new ej.DataManager(window.routeTerritories)
        .executeLocal(new ej.Query().where("Id", "equal", instance.option("value")));



    if (currentRouteList.length > 0) {
        var dataManager = ej.DataManager({
            url: "/Admin/Apps/SyncBus/Route/getCompanyscheduledroutes?companyid=" + companyid + "&routeid=" + currentRouteList[0].Id, //  This will trigger to bind the appointments data to schedule control
            batchUrl: "/Admin/Apps/SyncBus/Route/Crud", // This will trigger while saving the appointment through detail window
            insertUrl: "/Admin/Apps/SyncBus/Route/AddScheduledRoutes?companyid=" + companyid, // This will trigger while saving the appointment through quick window
            updateUrl: "/Admin/Apps/SyncBus/Route/UpdateCompanyScheduledRoutes?companyid=" + companyid, //This will trigger while saving the resize or drag and drop the appointment 
            removeUrl: "/Admin/Apps/SyncBus/Route/RemoveCompanyScheduledRoutes?companyid=" + companyid, // This will trigger to delete the single appointment
            adaptor: new ej.UrlAdaptor()
        });;

        // console.log(dataManager); AddScheduledRoutes
        //console.log(currentRouteList);
        //console.log(data);
        if (!ej.isNullOrUndefined($("#routeSchedule").ejSchedule("instance")))
            $("#routeSchedule").ejSchedule('destroy');
        $("#routeSchedule").ejSchedule({

            appointmentWindowOpen: onAppointmentWindowOpen,
            navigation: OnNavigation,
            queryCellInfo: "OnQueryCellInfo",
            cellClick: "OnCellClick",
            create: "onCreate",
            actionBegin: "onBegin",
            appointmentHover: "onHover",
            dragStop: "onAction",
            resizeStop: "onAction",
            actionComplete: "onComplete",
            cellHover: "onCellHover",
            dragStart: "onStart",
            resizeStart: "onStart",
            beforeAppointmentCreate: "OnBeforeAppointmentCreate",
            beforeAppointmentChange: "OnBeforeAppointmentChange",
            width: "100%",
            height: "725px",
            currentDate: new Date(window.startScheduleDay),
            views: ["Day", "Week", "Month", "Agenda"],
            currentView: ej.Schedule.CurrentView.Month,
            showNextPrevMonth: true,
            agendaViewSettings: {
                //Next 5 days Appointments lists out from current date
                daysInAgenda: 5
            },
            showAllDayRow: false,
            highlightBusinessHours: true,
            timeMode: window.timeMode,
            startHour: window.startHour,
            endHour: window.endHour,
            workHours: {
                hightlight: true,
                start: window.businessStartHour,
                end: window.businessEndHour
            },
            workWeek: window.workWeek,
            // orientation: (newlist.length > 2) ? "horizontal" : "vertical",
            // cellWidth: (newlist.length > 2) ? "100px" : "",
            appointmentSettings: {
                dataSource: dataManager,
                resourceFields: "TerritoryId, RouteId"
                //applyTimeOffset: false
            },
            group: {
                resources: ["Territories", "Routes"]
            },
            resources: [{
                field: "TerritoryId", title: "Territory", name: "Territories", allowMultiple: false,
                resourceSettings: { dataSource: $.extend(true, [], territoryList), text: "Text", id: "Id", groupId: "GroupId" }
            }, {
                field: "RouteId", title: "Route", name: "Routes", allowMultiple: true,
                resourceSettings: { dataSource: $.extend(true, [], currentRouteList), text: "Text", id: "Id", groupId: "GroupId", color: "Color" }
            }]
        });


        var scheduleObj = $("#routeSchedule").data("ejSchedule");
        
    }

}


function regionListChange(args) {
    var routeList = new ej.DataManager(window.routes).executeLocal(new ej.Query().where("GroupId", "equal", args.value));
    var territoryList = new ej.DataManager(window.routeTerritories).executeLocal(new ej.Query().where("Id", "equal", args.value));
    var companyid = $('#Id').val();
    var firstRouteList = routeList;
    $("#routeList").ejListBox({
        dataSource: routeList,
        fields: {
            id: "Id",
            text: "Text"
        }
    });

    if (routeList.length > 0) {
        firstRouteList = new ej.DataManager(window.routes).executeLocal(new ej.Query().where("Text", "equal", routeList[0].Text));

        var dataManager = ej.DataManager({
            url: "/Admin/Apps/SyncBus/Route/getCompanyscheduledroutes?companyid=" + companyid + "&routeid=" + firstRouteList[0].Id, //  This will trigger to bind the appointments data to schedule control
            batchUrl: "/Admin/Apps/SyncBus/Route/Crud", // This will trigger while saving the appointment through detail window
            insertUrl: "/Admin/Apps/SyncBus/Route/AddScheduledRoutes?companyid=" + companyid, // This will trigger while saving the appointment through quick window
            updateUrl: "/Admin/Apps/SyncBus/Route/UpdateCompanyScheduledRoutes?companyid=" + companyid, //This will trigger while saving the resize or drag and drop the appointment 
            removeUrl: "/Admin/Apps/SyncBus/Route/RemoveCompanyScheduledRoutes?companyid=" + companyid, // This will trigger to delete the single appointment
            adaptor: new ej.UrlAdaptor()
        });;

        if (!ej.isNullOrUndefined($("#routeSchedule").ejSchedule("instance")))
            $("#routeSchedule").ejSchedule('destroy');
        $("#routeSchedule").ejSchedule({

            appointmentWindowOpen: onAppointmentWindowOpen,
            navigation: OnNavigation,
            queryCellInfo: "OnQueryCellInfo",
            cellClick: "OnCellClick",
            create: "onCreate",
            actionBegin: "onBegin",
            appointmentHover: "onHover",
            dragStop: "onAction",
            resizeStop: "onAction",
            actionComplete: "onComplete",
            cellHover: "onCellHover",
            dragStart: "onStart",
            resizeStart: "onStart",
            beforeAppointmentCreate: "OnBeforeAppointmentCreate",
            beforeAppointmentChange: "OnBeforeAppointmentChange",
            width: "100%",
            height: "725px",
            currentDate: new Date(window.startScheduleDay),
            views: ["Day", "Week", "Month", "Agenda"],
            currentView: ej.Schedule.CurrentView.Month,
            showNextPrevMonth: true,
            agendaViewSettings: {
                //Next 5 days Appointments lists out from current date
                daysInAgenda: 14
            },
            showAllDayRow: false,
            highlightBusinessHours: true,
            timeMode: window.timeMode,
            startHour: window.startHour,
            endHour: window.endHour,
            workHours: {
                hightlight: true,
                start: window.businessStartHour,
                end: window.businessEndHour
            },
            workWeek: window.workWeek,
            // orientation: (newlist.length > 2) ? "horizontal" : "vertical",
            // cellWidth: (newlist.length > 2) ? "100px" : "",
            appointmentSettings: {
                dataSource: dataManager,
                resourceFields: "TerritoryId, RouteId"
                //applyTimeOffset: false
            },
            group: {
                resources: ["Territories", "Routes"]
            },
            resources: [{
                field: "TerritoryId", title: "Territory", name: "Territories", allowMultiple: false,
                resourceSettings: { dataSource: $.extend(true, [], territoryList), text: "Text", id: "Id", groupId: "GroupId" }
            }, {
                field: "RouteId", title: "Route", name: "Routes", allowMultiple: true,
                resourceSettings: { dataSource: $.extend(true, [], firstRouteList), text: "Text", id: "Id", groupId: "GroupId", color: "Color" }
            }]
        });

    }



}

/* Clear form fields */
function clearFields() {
    $("#customId").val("");
    $("#subject").val("");
    $("#customdescription").val("");
    $("#Category").val("");
    $("#deleteId").val("");
    $("#allday").prop("checked", false);
    $("#recurrence").prop("checked", false);
    $("tr.recurrence").css("display", "none");
    $("#EndTime").ejDateTimePicker({ enabled: true });
    var recObj = $("#recurrenceEditor").ejRecurrenceEditor('instance');
    recObj.clearRecurrenceFields();
    // console.log("clearfield");
}

/* Button Cancel */
// This function executes when the cancel button in the custom appointment window is pressed.
function cancel() {
    clearFields();
    $("#customWindow").ejDialog("close");
    $("#deleteWindow").ejDialog("close");
    $("#tokenWindow").ejDialog("close");
}

// This function executes when the subject text field is currently being focussed
function temp() {
    $("#subject").removeClass("error");
}


/* RecurrenceRule Generate or Cancel */
function onRecurrenceClick(args) {
    if ($(args.e.currentTarget).attr("id") == "recsubmit") {
        var recObj = $("#recurrenceEditor").ejRecurrenceEditor('instance');
        recObj.closeRecurPublic();
        window.recurRule = recObj._recRule;
        //  recurCheck();
        //$("#recsummary").html(recurRule);
    }
    if (($(args.e.currentTarget).attr("id") == "reccancel")) {
        $("#recurrence").ejCheckBox({ checked: false });
    }
    $("#recWindow").css("display", "none");
    $("#appWindow").css("display", "");

}

/* Recurrence Window Load */
function onRecurrenceRule() {
    $("#recWindow").css("display", "block");
    $("#appWindow").css("display", "none");
    window.recurRule = window.appointmentRule;
}

function OnCellClick(args) {
   
    args.cancel = true;        //Block the quick window open.
    if (ej.isNullOrUndefined(args.appointment)) {
        if (args.startTime.setHours(0, 0, 0, 0) < new Date().setHours(0, 0, 0, 0))
            args.cancel = true;
    }
    else {
        if (new Date(args.appointment.StartTime).setHours(0, 0, 0, 0) < new Date().setHours(0, 0, 0, 0))
            args.cancel = true;
    }
}


function onAppointmentWindowOpen(args) {

    var schObj = $("#routeSchedule").ejSchedule('instance');
    args.cancel = true;
    if (ej.isNullOrUndefined(args.appointment)) {
        if (args.startTime.setHours(0, 0, 0, 0) < new Date().setHours(0, 0, 0, 0)) {
            args.cancel = true;
            return;
        }
    }
    else {
        if (new Date(args.appointment.StartTime).setHours(0, 0, 0, 0) < new Date().setHours(0, 0, 0, 0)) {
            args.cancel = true;
            return;
        }
            
    }
    $("#recurrence").ejCheckBox({ checked: false, enabled: true });
    $("#recWindow").css("display", "none");
    $("#editApp").css("display", "none");
    $("#appWindow").css("display", "block");

    // When double clicked on the Scheduler cells, fills the StartTime and EndTime fields appropriately
    $("#StartTime").ejDateTimePicker({ value: args.startTime });
    $("#EndTime").ejDateTimePicker({ value: args.endTime });
    $("#recWindow").css("display", "none");
    $("#appWindow").css("display", "");
    $('#subject').val(subjectTime(new Date(args.endTime)));
    if (ej.isNullOrUndefined(args.appointment)) {
        $("#recurrenceEditor")
           .find("#startsoncount")
           .find("#" + "recurrenceEditor" + "_recurstartdate")
           .ejDatePicker("option",
           {
               value: ej.format(new Date(args.endTime), this._datepattern(), this.model.locale)
           });
    }



    if (args.model.currentView == "month") {
        var currentDate = new Date();
        var appointedDate = new Date(args.endTime);
        var currentappointedTime = new Date(appointedDate.getFullYear(),
            appointedDate.getMonth(),
            appointedDate.getDate(),
            currentDate.getHours(),
            currentDate.getMinutes(),
            currentDate.getSeconds());
        $("#StartTime").ejDateTimePicker({ value: subtract_minutes(currentappointedTime, window.checkInMinutes) });
        $("#EndTime").ejDateTimePicker({ value: currentappointedTime });
        $('#subject').val(subjectTime(new Date(currentappointedTime)));


    }


    if (ej.isNullOrUndefined(args.edit)) {
        var res = args.model.resources[0].resourceSettings.dataSource;
        $("#Territory").ejDropDownList({ dataSource: res, width: "100%", fields: { text: "Text", id: "Td", value: "Text" } });

        var res2 = new ej.DataManager(res).executeLocal(new ej.Query().where(args.model.resources[args.model.resources.length - 1].resourceSettings["id"],
            ej.FilterOperators.equal, args.resources.GroupId));
        var res1 = new ej.DataManager(args.model.resources[args.model.resources.length - 1].resourceSettings.dataSource).executeLocal(new ej.Query().where
            (args.model.resources[args.model.resources.length - 1].resourceSettings["groupId"], ej.FilterOperators.equal, args.resources.GroupId));
        $("#TerritoryRoutes").ejDropDownList({ dataSource: res1, width: "100%", fields: { text: "Text", id: "Td", value: "Text" } });

        $("#TerritoryRoutes").data("ejDropDownList").selectItemByText(args.resources.Text);
        $("#Territory").data("ejDropDownList").selectItemByText(res2[0].Text);

    } else {

        var res = new ej.DataManager(args.model.resources[0].resourceSettings.dataSource).executeLocal(new ej.Query().where(args.model.resources[0].resourceSettings["id"], ej.FilterOperators.equal, args.appointment.TerritoryId));
        // $("#Territory").data("ejDropDownList").selectItemByText(res[0].Text);
        $("#Territory").ejDropDownList({ dataSource: args.model.resources[0].resourceSettings.dataSource, fields: { text: "Text", id: "Id", value: "Text" } });
        $("#Territory").data("ejDropDownList").selectItemByText(res[0].Text);
        var res2 = new ej.DataManager(args.model.resources[args.model.resources.length - 1].resourceSettings.dataSource).executeLocal(new ej.Query().where(args.model.resources[args.model.resources.length - 1].resourceSettings["groupId"], ej.FilterOperators.equal, res[0].Id));
        $("#TerritoryRoutes").ejDropDownList({ dataSource: res2, fields: { text: "Text", id: "Id", value: "Text" } });
        var res1 = new ej.DataManager(args.model.resources[args.model.resources.length - 1].resourceSettings.dataSource).executeLocal(new ej.Query().where(args.model.resources[args.model.resources.length - 1].resourceSettings["id"], ej.FilterOperators.equal, args.appointment.RouteId));
        $("#TerritoryRoutes").data("ejDropDownList").selectItemByText(res1[0].Text);
        window.appedit = ej.isNullOrUndefined(args.waitinglistedit) ? true : false;
    }


    if (!ej.isNullOrUndefined(args.target)) {
        $('#recurrence').prop('disabled', false);
        recurCheck();
        $("#EndTime").ejDateTimePicker({
            enabled: ($(args.target.currentTarget).hasClass("e-alldaycells")) ? false : true
        });

    }
    if (!ej.isNullOrUndefined(args.appointment)) {
        window.appointmentRule = null;
        $("#customId").val(args.appointment.Id);
        $("#subject").val(args.appointment.Subject);
        $("#StartTime").ejDateTimePicker({ value: new Date(args.appointment.StartTime) });
        $("#EndTime").ejDateTimePicker({ value: new Date(args.appointment.EndTime) });
        // $("#recurrence").ejCheckBox({ checked: args.appointment.Recurrence });
        if (args.appointment.Recurrence) {
            $("#recurrence")
                .ejCheckBox({
                    checked: args.appointment.Recurrence,
                    enabled: (schObj._currentAction == "editSeries") ? true : false
                });
            if (schObj._currentAction == "editSeries") {
                $("#editApp").css("display", "block");
                window.appointmentRule = args.appointment.RecurrenceRule;
                $("#recurrenceEditor").find("#startsoncount")
                    .find("#" + "recurrenceEditor" + "_recurstartdate")
                     .ejDatePicker("option",
                            {
                                 value: ej.format(new Date(args.appointment.EndTime), this._datepattern(), this.model.locale)
                            });
            }
            var recObj = $("#recurrenceEditor").ejRecurrenceEditor('instance');
            recObj._recRule = args.appointment.RecurrenceRule; // app recurrence rule is stored in Recurrence editor object
            recObj.recurrenceRuleSplit(args.appointment.RecurrenceRule, args.appointment.recurrenceExDate); //splitting the recurrence rule
            recObj.showRecurrenceSummary(args.appointment.Id);
            window.recurRule = recObj._recRule;
            if (recObj._rRule.count !== undefined) {
                if (recObj._rRuleFreq == "DAILY") {
                    var newd = moment(new Date(args.appointment.EndTime));
                    var maxEndDate = newd.add((recObj._rRule.count - 1) * recObj._interval, 'days');
                    $("#recurrenceEditor").find("#endsonuntil").find("#" + "recurrenceEditor" + "_daily").ejDatePicker("option", {

                        value: ej.format(new Date(maxEndDate), this._datepattern(), this.model.locale)
                    });
                }
                
            }
        } else
            $("#recurrence").ejCheckBox({ checked: false, enabled: true });
        $("#recWindow").css("display", "none");
        $("#appWindow").css("display", "block");
    }


    $("#customWindow").ejDialog("open");

}

function save() {
    // checks if the subject value is not left blank before saving it.
    if ($.trim($("#subject").val()) == "") {
        $("#subject").addClass("error");
        return false;
    }
    var obj = {}, temp = {}, rType;
    var formelement = $("#customWindow").find("#custom").get(0);
    for (var index = 0; index < formelement.length; index++) {
        var columnName = formelement[index].name, $element = $(formelement[index]);
        if (columnName != undefined) {
            if (columnName == "")
                columnName = formelement[index].id.replace(this._id, "");
            if (columnName != "" && obj[columnName] == null) {
                var value = formelement[index].value;
                if (columnName == "Id" && value != "") {
                    value = parseInt(value);
                    window.appointedit = true;
                }
                if ($element.hasClass("e-datetimepicker"))
                    value = new Date(value);
                if (formelement[index].type == "checkbox")
                    value = formelement[index].checked;
                if (formelement[index].type == "hidden") {

                    var resdata = (columnName == "Territory") ? window.routeTerritories : window.routes;
                    var territoryId = new ej.DataManager(resdata).executeLocal(new ej.Query().where("Text", ej.FilterOperators.equal, value));
                    if (territoryId.length > 0)
                        (columnName == "Territory") ? obj["TerritoryId"] = territoryId[0].Id : obj["RouteId"] = territoryId[0].Id;
                }
                if (columnName != "Territory_hidden" &&
                    //columnName != "TerritoryRoutes" &&
                    columnName != "TerritoryRoutes_hidden") {
                    // console.log({ columnName, $element, value });
                    obj[columnName] = value;
                }
            }
        }
    }
 
    obj['RecurrenceRule'] = (obj.Recurrence) ? window.recurRule : null;
    obj["CompanyId"] = $('#Id').val();
    $("#customWindow").ejDialog("close");
  
    //var schObj = $("#routeSchedule").ejSchedule('instance');
    var schObj = $("#routeSchedule").data("ejSchedule");
    if (obj.Recurrence) {
        var recurEdit = schObj._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor");
        recurEdit._recRule = obj[schObj._appointmentSettings["recurrenceRule"]];
    }

    schObj.saveAppointment(obj);
    clearFields();
}

/* Appointment Save or Cancel */
function onAppointmentClick(args) {
    if ($(args.e.currentTarget).attr("id") == "appsubmit") save();
    else cancel();
}

function recurCheck() {
   
    var recChkObj = $("#recurrence").ejCheckBox('instance');
    if (recChkObj.checked()) {
        $("#recWindow").css("display", "block");
        $("#appWindow").css("display", "none");
    }
    else {
        $("#recWindow").css("display", "none");
    }



}

var subtract_minutes = function (dt, minutes) {
    var msec = Date.parse(dt);
    var d = new Date(msec);
    return new Date(d.getTime() - minutes * 60000);
}

var subjectTime = function (myDate) {
    var newd = moment(myDate);
    var format = "h:mm A";
    var format2 = "HH:mm";
    if (window.timeMode == "24")
        return newd.format(format2);
    return newd.format(format);
}

function changeState(args) {
    var dateTimeObj = $('#StartTime').data("ejDateTimePicker");
    if (args.isChecked) {
        dateTimeObj.enable();
    }
    else {
        dateTimeObj.disable();
    }
}

function changeDepartureTime(args) {
    var dateTimeObj = $('#EndTime').data("ejDateTimePicker");
    var etaDateTimeObj = $('#StartTime').data("ejDateTimePicker");
    etaDateTimeObj.option('value', subtract_minutes(dateTimeObj.getValue(), window.checkInMinutes));

    var newd = moment(new Date(dateTimeObj.getValue()));
    var format = "h:mm A";
    var format2 = "HH:mm";

    $('#subject').val(newd.format(format));
    if (window.timeMode == "24")
        $('#subject').val(newd.format(format2));

}



function onRecurChange(args) {
   
    var startd = moment(new Date());
    var maxStartd = startd.add(window.maxRecurDays, 'days');
    var $this = $("#recurrenceEditor");

    $this.find("#startsoncount")
        .find("#" + this._id + "_recurstartdate")
        .ejDatePicker("option",
        {
            minDate: ej.format(new Date(), this._datepattern(), this.model.locale),
            maxDate: ej.format(new Date(maxStartd), this._datepattern(), this.model.locale)
        });

    var newd = moment(new Date(args.model.startDate));
    var maxEndDate = newd.add(window.maxRecurDays, 'days');
    $this.find("#endsonuntil").find("#" + this._id + "_daily").ejDatePicker("option", {
        minDate: ej.format(new Date(), this._datepattern(), this.model.locale),
        maxDate: ej.format(new Date(maxEndDate), this._datepattern(), this.model.locale),
        // value: ej.format(new Date(maxEndDate), this._datepattern(), this.model.locale)
    });


}

function OnQueryCellInfo(args) {
    switch (args.requestType) {
        case "workcells":

            if (args.cell.endTime === undefined || args.cell.startTime === undefined) {
                if (args.element.hasClass('e-workcells')) {
                    args.element.addClass('sync-celldisable');
                }

                if (args.element.hasClass('e-workcells e-alternatecells')) {
                    args.element.addClass('sync-celldisable');
                }
                args.element.css("background-color", "#b6bfc8");
            }
            break;
        case "monthcells":
            if (args.cell.currentDate === undefined) {
                args.element.css("background-color", "#7c8c9c");
            }
            break;

    }

}

function OnBeforeAppointmentCreate(args) {
    if (ej.isNullOrUndefined(args.appointment[0]))
        app = args.appointment;
    else
        app = args.appointment[0];
    if (new Date(app.StartTime).setHours(0, 0, 0, 0) < new Date().setHours(0, 0, 0, 0))
        args.cancel = true;
}

function OnBeforeAppointmentChange(args) {
    if (new Date(args.appointment.StartTime).setHours(0, 0, 0, 0) < new Date().setHours(0, 0, 0, 0))
        args.cancel = true;
}

function onStart(args) {
    if (new Date(args.appointment.StartTime).setHours(0, 0, 0, 0) < new Date().setHours(0, 0, 0, 0))
        args.cancel = true;
}

function onCellHover(args) {
    if (new Date(args.currentDate).setHours(0, 0, 0, 0) < new Date().setHours(0, 0, 0, 0))
        args.cancel = true;
}

function onCreate() {
    var scheduleObj = $("#routeSchedule").data("ejSchedule");
    if (scheduleObj.currentView() == "month") {
        var monthElements = scheduleObj.element.find(".e-monthcells");
        var dayIndex = scheduleObj._dateRender.indexOf(new Date().setHours(0, 0, 0, 0));
        for (var a = 0, len = scheduleObj._dateRender.length; a < len; a++) {
            if (scheduleObj._dateRender[a] < new Date().setHours(0, 0, 0, 0)) {
                monthElements.eq(a).addClass("e-othermonths e-disable sync-celldisable");
                var dateheader2 = monthElements.eq(a).find(".e-monthheader");
                dateheader2.addClass("sync-monthheader");
            }
               
        }
    }
    else {
        var allDayElements = scheduleObj.element.find(".e-alldaycells");
        for (var b = 0, len = scheduleObj._dateRender.length; b < len; b++) {
            if (scheduleObj._dateRender[b] < new Date().setHours(0, 0, 0, 0)) {
                scheduleObj.element.find(".e-workcellstab tr td:nth-child(" + (b + 1) + ")").addClass("e-disable");
                allDayElements.eq(b).addClass("e-disable");
            }
            else {
                scheduleObj.element.find(".e-workcellstab tr td:nth-child(" + (b + 1) + ")").removeClass("e-disable");
                allDayElements.eq(b).removeClass("e-disable");
            }
        }
    }
}

function onComplete(args) {
    if (args.requestType === "dateNavigate" || args.requestType === "viewNavigate")
        onCreate();
}

function onBegin(args) {
    if (args.requestType == "appointmentResize" || args.requestType == "appointmentDrag") {
        if (args.data.appointment.StartTime.getMonth() != new Date().getMonth())
            args.cancel = true;
    }
}
function onHover(args) {
    if (new Date(args.appointment.StartTime).setHours(0, 0, 0, 0) < new Date().setHours(0, 0, 0, 0))
        args.cancel = true;

}
function onAction(args) {
    if (new Date(args.appointment.StartTime).setHours(0, 0, 0, 0) < new Date().setHours(0, 0, 0, 0))
        args.cancel = true;
}
